# first a few useful aliases
al d   "dir -hq"  # hides .info and block lengths
al lst "ls -t"    # sorts by access time
al lsl "ls -l"    #sorts by length

# sc searches *.c, even 'sc -c main()' works
al sc "%a search @pickopts( $a ) *.c @pickargs( $a )

# edf edits a function in CygnusEd if the name starts in the first column:
al edf "%func set b \"\";search -afl *.c $func | inp b;\
 if $b;split b file line;ed $file;waitforport rexx_ced;\
  inc line 1;rxs rexx_ced \"jump to file \"$file \"jumpto \"$line\" 0\";\
 else;\
  echo Not found;\
 endif

# this aliases suppress wild card expansion for certain commands
al zoo     "*a Zoo $a
al lharc   "*a Lharc $a
al lz      "*a Lz $a
al newlist "*a Newlist $a

# pushd pushes the current directory on a stack
# popd  retrieves it from there
set stk ""
al pushd   "set stk $_cwd @subwords( $stk 1 10 )
al popd    "\\cd @first( $stk );set stk @subwords( $stk 2 10 )

# this one will show all pictures, the newest first
al newpix  "ls -nt | forline i STDIN \"ShowIFF $i

#shift-arrow-up will retrieve an abbreviated line from history
keymap 0 768=24
